package org.openecu.comm;

/**
 * User: tjennings
 * Date: May 29, 2005
 * Time: 12:30:30 PM
 */
public class ECUMonitorFactory {
    public static final String MONITOR = "monitor";

    public static ECUMonitor getMonitor() throws CommunicationException {
        return loadMonitor();
    }

    private static ECUMonitor loadMonitor() throws CommunicationException {
        try {
            Object o = Class.forName(System.getProperty(MONITOR)).newInstance();
            return (ECUMonitor) o;
        } catch (ClassNotFoundException cnfe) {
            throw new CommunicationException(cnfe);
        } catch (InstantiationException ie) {
            throw new CommunicationException(ie);
        } catch (IllegalAccessException iae) {
            throw new CommunicationException(iae);
        }
    }
}
