package org.openecu.gui.renderer;

import org.openecu.param.ECUParameter;
import org.openecu.param.Parameter;

import java.util.List;

/**
 * User: tjennings
 * Date: Jun 2, 2005
 * Time: 7:33:38 PM
 */
public class ConsoleRenderer extends Renderer {
    private static final String SPACE = " ";

    public ConsoleRenderer(List <Parameter> p) {
        super(p);
    }

    public ConsoleRenderer() {
        super();
    }

    public void shutDown() throws RenderException {
        //do nothing
    }

    protected void render() {
        StringBuilder sb = new StringBuilder();

        for(Parameter p : _params) {
            sb.append(p.getName()).append(":").append(SPACE);
            sb.append(p.getResult()).append(SPACE);
        }
        sb.append("\n");
        System.out.println(sb.toString());
    }
}
