package org.openecu.param;

import org.openecu.util.UnsignedByte;
import org.openecu.param.conversion.ConversionHandler;

import java.util.Observable;

/**
 * User: tjennings
 * Date: May 25, 2005
 * Time: 8:12:38 PM
 */
public class ECUParameter extends Parameter {
    private UnsignedByte _query[];
    private UnsignedByte _result;
    private String _name;
    private ConversionHandler _handler;

    public ECUParameter(UnsignedByte[] q, String name, ConversionHandler handler) {
        _query = q;
        _name = name;
        _handler = handler;
    }

    public String getName() {
        return _name;
    }

    public void setResult(UnsignedByte r) {
        _result = r;
        setChanged();
        notifyObservers();
    }

    public float getResult() {
        return _handler.intResult(_result);
    }

    public byte[] getQuery() {
        return new byte[] {_query[0].byteValue(), _query[1].byteValue(), _query[2].byteValue()};
    }

    public int getQueryLength() {
        return 1;
    }
}
