package org.openecu.param;

import org.openecu.param.loader.XMLParameterLoader;
import org.openecu.param.special.TimeParameter;
import org.openecu.param.special.RateParameter;
import org.openecu.Globals;

import java.util.Map;

/**
 * User: tjennings
 * Date: May 26, 2005
 * Time: 9:52:50 PM
 */
public class ParameterRegistry {
    public static Map<String, Parameter> _paramMap;

    public static Parameter getParamForName(String name) throws ParameterException {
        if (_paramMap == null) loadParams();
        if(!_paramMap.containsKey(name)) throw new ParameterException("Invalid parameter specified: " + name);
        return _paramMap.get(name);
    }

    public static void loadParams() throws ParameterException {
        XMLParameterLoader loader = new XMLParameterLoader();
        _paramMap = loader.loadParams();
        _paramMap.putAll(loader.loadMetaParams());

        //Normal Special Parameters
        _paramMap.put(Globals.TIME_PARAM, new TimeParameter());

        //Meta Special Parameters
        _paramMap.put(Globals.RATE_PARAM, new RateParameter());
    }
}
