package org.openecu.param.meta;

import org.openecu.param.Parameter;
import org.openecu.param.ParameterException;
import org.openecu.param.ParameterRegistry;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Observable;

/**
 * User: tjennings
 * Date: Jun 2, 2005
 * Time: 8:57:50 PM
 */
public class EGTFParam extends MetaParameter {
    private Parameter _egtc;
    private String _name;

    public EGTFParam() {
        _egtc = null;
        _name = null;
    }

    public EGTFParam(String name, Map<String, String> args) throws ParameterException {
        setArgs(args);
        _name = name;
    }

    public List<Parameter> getDependants() {
        return Collections.singletonList(_egtc);
    }

    public String getName() {
        return _name;
    }

    public void setName(String name) {
        _name = name;
    }

    public void setArgs(Map<String, String> args) throws ParameterException {
        _egtc = ParameterRegistry.getParamForName(args.get("EGTC"));
        _egtc.addObserver(this);
    }

    public float getResult() {
        return _egtc.getResult() * 1.8f + 32;
    }

    public void update(Observable o, Object arg) {
        setChanged();
        notifyObservers();
    }
}
