package org.openecu.param.meta;

import org.openecu.param.Parameter;
import org.openecu.param.ParameterException;
import org.openecu.param.ParameterRegistry;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.Observable;

/**
 * User: tjennings
 * Date: Jun 2, 2005
 * Time: 8:57:50 PM
 */
public class MPHParam extends MetaParameter {
    private Parameter _kph;
    private String _name;

    public MPHParam() {
        _kph = null;
        _name = null;
    }

    public MPHParam(String name, Map<String, String> args) throws ParameterException {
        setArgs(args);
        _name = name;
    }

    public List<Parameter> getDependants() {
        return Collections.singletonList(_kph);
    }

    public String getName() {
        return _name;
    }

    public void setName(String name) {
        _name = name;
    }

    public void setArgs(Map<String, String> args) throws ParameterException {
        _kph = ParameterRegistry.getParamForName(args.get("KPH"));
        _kph.addObserver(this);
    }

    public float getResult() {
        return _kph.getResult() * 0.6215f;
    }

    public void update(Observable o, Object arg) {
        setChanged();
        notifyObservers();
    }
}
