package org.openecu.param.meta;

import org.openecu.param.ECUParameter;
import org.openecu.param.Parameter;
import org.openecu.param.ParameterRegistry;
import org.openecu.param.ParameterException;

import java.util.List;
import java.util.Observable;
import java.util.ArrayList;
import java.util.Map;

/**
 * User: tjennings
 * Date: Jun 2, 2005
 * Time: 8:57:50 PM
 */
public class RPMParam extends MetaParameter {
    private Parameter _rpmh;
    private Parameter _rpml;
    private String _name;
    private int updCnt;

    public RPMParam() {
        _rpmh = null;
        _rpml = null;
        _name = null;
        updCnt = 0;
    }

    public RPMParam(String name, Map<String, String> args) throws ParameterException {
        setArgs(args);
        _name = name;
        updCnt = 0;
    }

    public List<Parameter> getDependants() {
        ArrayList<Parameter> pList = new ArrayList<Parameter>();
        pList.add(_rpmh);
        pList.add(_rpml);

        return pList;
    }

    public String getName() {
        return _name;
    }

    public void setName(String name) {
        _name = name;
    }

    public void setArgs(Map<String, String> args) throws ParameterException {
        _rpmh = ParameterRegistry.getParamForName(args.get("RPMH"));
        _rpml = ParameterRegistry.getParamForName(args.get("RPML"));
        _rpmh.addObserver(this);
        _rpml.addObserver(this);
    }

    public float getResult() {
        return (_rpmh.getResult() + _rpml.getResult()) / 4;
    }

    public void update(Observable o, Object arg) {
        updCnt++;
        if(updCnt == 2) {
            setChanged();
            notifyObservers();
            updCnt = 0;
        }
    }
}
