package org.openecu.param.special;

import org.openecu.param.meta.MetaParameter;
import org.openecu.param.Parameter;
import org.openecu.param.ParameterException;
import org.openecu.param.ParameterRegistry;
import org.openecu.Globals;

import java.util.*;

/**
 * User: tjennings
 * Date: Jun 5, 2005
 * Time: 7:05:02 PM
 */
public class RateParameter extends MetaParameter {
    private Parameter _time;
    private float _lastTime = 0;
    private float _rate = 0;

    public RateParameter() throws ParameterException {
        _time = ParameterRegistry.getParamForName(Globals.TIME_PARAM);
        _time.addObserver(this);
    }
    public List<Parameter> getDependants() {
        return Collections.singletonList(_time);
    }

    public void setName(String name) {
        //Do nothing
    }

    public void setArgs(Map<String, String> args) throws ParameterException {
        //Do nothing
    }

    public String getName() {
        return Globals.RATE_PARAM;
    }

    public float getResult() {
        return _rate;
    }

    public void update(Observable o, Object arg) {

        float interval = _time.getResult() - _lastTime;
        _lastTime = _time.getResult();        
        _rate = 60 / (interval * 60);

        this.setChanged();
        this.notifyObservers();
    }
}
